#ifndef __CONEX_H
#define __CONEX_H

#include <string>
#include <iostream>
#include <vector>
#include <cstdlib>
#include <unistd.h>
#include <TMath.h>
#include <TTree.h>
#include <TFile.h>
#include <TSystem.h>
#include <TStopwatch.h>

// --------------  forward declarations

extern "C"
{
  void crmc_f_( int&, double&, int&, double&, double&, double&,
                double&, double&);
};

extern "C"
{
  void crmc_init_f_( int&, double&, double&, int&, int&, int&, const char*);
};

bool   GetOptions(int,char**);
void   rootOut(int);
void   cleanVector();

// --------------  default options
int    gNCollision=1;
int    gSeed=123;
int    gBeamID=120;
int    gTargetID=12;
int    gHEModel=0;
double gBeamMomentum=300;
double gTargetMomentum=0;
std::string gParamFileName="crmc.param";
std::string gPrefix = "na61";


// --------------  Tree data
const unsigned int gMaxParticles = 9990; // HEP max number of particles

int gNParticles = 0;
double gImpactParameter = 0;
static int gPartID[gMaxParticles];
static double gPartPx[gMaxParticles];
static double gPartPy[gMaxParticles];
static double gPartPz[gMaxParticles];
static double gPartEnergy[gMaxParticles];
static double gPartMass[gMaxParticles];

// for timing
TStopwatch gStopwatch;

#endif
